
_ADC_value:

;ADC_without_library.c,21 :: 		unsigned int ADC_value(short int canal)
;ADC_without_library.c,22 :: 		{       unsigned int valor =0;
;ADC_without_library.c,25 :: 		ADMUX &=~  0x0F;
	LDS        R16, ADMUX+0
	ANDI       R16, 240
	STS        ADMUX+0, R16
;ADC_without_library.c,26 :: 		ADMUX |=  canal;
	OR         R16, R2
	STS        ADMUX+0, R16
;ADC_without_library.c,29 :: 		ADCSRA |= (1<<ADEN);
	LDS        R27, ADCSRA+0
	SBR        R27, 128
	STS        ADCSRA+0, R27
;ADC_without_library.c,30 :: 		delay_us(10);	// wait a moment for the stability.
	LDI        R16, 53
L_ADC_value0:
	DEC        R16
	BRNE       L_ADC_value0
	NOP
;ADC_without_library.c,33 :: 		ADCSRA |= (1<<ADSC);
	LDS        R16, ADCSRA+0
	ORI        R16, 64
	STS        ADCSRA+0, R16
;ADC_without_library.c,36 :: 		while( !(ADCSRA & (1<<ADIF)) );
L_ADC_value2:
	LDS        R16, ADCSRA+0
	SBRC       R16, 4
	JMP        L_ADC_value3
	JMP        L_ADC_value2
L_ADC_value3:
;ADC_without_library.c,37 :: 		ADCSRA |= (1<<ADIF);	// Reset the flag.
	LDS        R16, ADCSRA+0
	ORI        R16, 16
	STS        ADCSRA+0, R16
;ADC_without_library.c,40 :: 		ADCSRA &=~ (1<<ADEN);
	LDS        R16, ADCSRA+0
	ANDI       R16, 127
	STS        ADCSRA+0, R16
;ADC_without_library.c,41 :: 		valor = ADCL;      //Merge the adcl register with adch register and
; valor start address is: 18 (R18)
	LDS        R18, ADCL+0
	LDI        R19, 0
;ADC_without_library.c,42 :: 		valor |= ADCH<<8;   //after that send the result.
	LDS        R16, ADCH+0
	MOV        R17, R16
	CLR        R16
	OR         R16, R18
	OR         R17, R19
; valor end address is: 18 (R18)
;ADC_without_library.c,43 :: 		return valor;
;ADC_without_library.c,44 :: 		}
L_end_ADC_value:
	RET
; end of _ADC_value

_printV:

;ADC_without_library.c,46 :: 		void  printV() {
;ADC_without_library.c,49 :: 		ch = volt / 1000;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	LDI        R20, 232
	LDI        R21, 3
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _volt+0
	LDS        R17, _volt+1
	LDS        R18, _volt+2
	LDS        R19, _volt+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
;ADC_without_library.c,50 :: 		Lcd_Chr(2,6,48+ch);
	SUBI       R16, 208
	MOV        R4, R16
	LDI        R27, 6
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
;ADC_without_library.c,51 :: 		Lcd_Chr(2,7,'.');
	LDI        R27, 46
	MOV        R4, R27
	LDI        R27, 7
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Chr+0
;ADC_without_library.c,52 :: 		ch = (volt / 100 )% 10;
	LDI        R20, 100
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _volt+0
	LDS        R17, _volt+1
	LDS        R18, _volt+2
	LDS        R19, _volt+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;ADC_without_library.c,53 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
;ADC_without_library.c,54 :: 		ch = (volt / 10 )% 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _volt+0
	LDS        R17, _volt+1
	LDS        R18, _volt+2
	LDS        R19, _volt+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;ADC_without_library.c,55 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
;ADC_without_library.c,56 :: 		ch = volt % 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _volt+0
	LDS        R17, _volt+1
	LDS        R18, _volt+2
	LDS        R19, _volt+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
;ADC_without_library.c,57 :: 		Lcd_Chr_CP(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _Lcd_Chr_CP+0
;ADC_without_library.c,58 :: 		Delay_ms(50);
	LDI        R18, 5
	LDI        R17, 15
	LDI        R16, 242
L_printV4:
	DEC        R16
	BRNE       L_printV4
	DEC        R17
	BRNE       L_printV4
	DEC        R18
	BRNE       L_printV4
;ADC_without_library.c,59 :: 		}
L_end_printV:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _printV

_ADC_SET_UP:

;ADC_without_library.c,61 :: 		void  ADC_SET_UP() {
;ADC_without_library.c,64 :: 		ADMUX &=~ (1<<ADLAR);
	LDS        R16, ADMUX+0
	ANDI       R16, 223
	STS        ADMUX+0, R16
;ADC_without_library.c,67 :: 		ADMUX |=  (1<<REFS0);
	ORI        R16, 64
	STS        ADMUX+0, R16
;ADC_without_library.c,68 :: 		ADMUX &=~ (1<<REFS1);
	ANDI       R16, 127
	STS        ADMUX+0, R16
;ADC_without_library.c,71 :: 		ADCSRA |= (1<<ADPS0);
	LDS        R16, ADCSRA+0
	ORI        R16, 1
	STS        ADCSRA+0, R16
;ADC_without_library.c,72 :: 		ADCSRA |= (1<<ADPS1);
	LDS        R27, ADCSRA+0
	SBR        R27, 2
	STS        ADCSRA+0, R27
;ADC_without_library.c,73 :: 		ADCSRA |= (1<<ADPS2);
	LDS        R16, ADCSRA+0
	ORI        R16, 4
	STS        ADCSRA+0, R16
;ADC_without_library.c,74 :: 		}
L_end_ADC_SET_UP:
	RET
; end of _ADC_SET_UP

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;ADC_without_library.c,75 :: 		void main() {
;ADC_without_library.c,77 :: 		DDC2_bit=0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	IN         R27, DDC2_bit+0
	CBR        R27, BitMask(DDC2_bit+0)
	OUT        DDC2_bit+0, R27
;ADC_without_library.c,78 :: 		ADC_SET_UP();
	CALL       _ADC_SET_UP+0
;ADC_without_library.c,79 :: 		Lcd_Init();                        // Initialize LCD.
	CALL       _Lcd_Init+0
;ADC_without_library.c,80 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display.
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;ADC_without_library.c,81 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off.
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;ADC_without_library.c,82 :: 		Lcd_Out(1, 4, "Voltage");
	LDI        R27, #lo_addr(?lstr1_ADC_without_library+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr1_ADC_without_library+0)
	MOV        R5, R27
	LDI        R27, 4
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ADC_without_library.c,84 :: 		while (1) {
L_main6:
;ADC_without_library.c,86 :: 		adc_rd= ADC_value(2);
	LDI        R27, 2
	MOV        R2, R27
	CALL       _ADC_value+0
	STS        _adc_rd+0, R16
	STS        _adc_rd+1, R17
;ADC_without_library.c,87 :: 		volt = (long)adc_rd * 5000; //get the voltage values.
	LDI        R18, 0
	MOV        R19, R18
	LDI        R20, 136
	LDI        R21, 19
	LDI        R22, 0
	LDI        R23, 0
	CALL       _HWMul_32x32+0
	STS        _volt+0, R16
	STS        _volt+1, R17
	STS        _volt+2, R18
	STS        _volt+3, R19
;ADC_without_library.c,88 :: 		volt = volt / 1023;
	LDI        R20, 255
	LDI        R21, 3
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	STS        _volt+0, R16
	STS        _volt+1, R17
	STS        _volt+2, R18
	STS        _volt+3, R19
;ADC_without_library.c,89 :: 		delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_main8:
	DEC        R16
	BRNE       L_main8
	DEC        R17
	BRNE       L_main8
	NOP
;ADC_without_library.c,90 :: 		printV();
	CALL       _printV+0
;ADC_without_library.c,91 :: 		}
	JMP        L_main6
;ADC_without_library.c,92 :: 		}
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
