#line 1 "C:/Users/Usuario/Documents/MikroC_pro_avr/ADC_atmega328p/ADC_without_library.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 4 "C:/Users/Usuario/Documents/MikroC_pro_avr/ADC_atmega328p/ADC_without_library.c"
long volt;
unsigned int adc_rd=0;

sbit LCD_RS at PORTD2_bit;
sbit LCD_EN at PORTD3_bit;
sbit LCD_D4 at PORTD4_bit;
sbit LCD_D5 at PORTD5_bit;
sbit LCD_D6 at PORTD6_bit;
sbit LCD_D7 at PORTD7_bit;

sbit LCD_RS_Direction at DDD2_bit;
sbit LCD_EN_Direction at DDD3_bit;
sbit LCD_D4_Direction at DDD4_bit;
sbit LCD_D5_Direction at DDD5_bit;
sbit LCD_D6_Direction at DDD6_bit;
sbit LCD_D7_Direction at DDD7_bit;

unsigned int ADC_value(short int canal)
{ unsigned int valor =0;


 ADMUX &=~ 0x0F;
 ADMUX |= canal;


 ADCSRA |= (1<<ADEN);
 delay_us(10);


 ADCSRA |= (1<<ADSC);


 while( !(ADCSRA & (1<<ADIF)) );
 ADCSRA |= (1<<ADIF);


 ADCSRA &=~ (1<<ADEN);
 valor = ADCL;
 valor |= ADCH<<8;
 return valor;
}

void printV() {
 unsigned char ch ;

 ch = volt / 1000;
 Lcd_Chr(2,6,48+ch);
 Lcd_Chr(2,7,'.');
 ch = (volt / 100 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = (volt / 10 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = volt % 10;
 Lcd_Chr_CP(48+ch);
 Delay_ms(50);
}

void ADC_SET_UP() {


 ADMUX &=~ (1<<ADLAR);


 ADMUX |= (1<<REFS0);
 ADMUX &=~ (1<<REFS1);


 ADCSRA |= (1<<ADPS0);
 ADCSRA |= (1<<ADPS1);
 ADCSRA |= (1<<ADPS2);
}
void main() {

 DDC2_bit=0;
 ADC_SET_UP();
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1, 4, "Voltage");

 while (1) {

 adc_rd= ADC_value(2);
 volt = (long)adc_rd * 5000;
 volt = volt / 1023;
 delay_ms(10);
 printV();
 }
}
